#! /bin/sh
#
#Get the absolute path of the installation location
if [ "$#" -lt  1 ] ; then
	echo "Usage : $0 install/remove [ServiceName]"
	exit 1 
fi

INSTALL_LOCATION=`dirname "$0"`
CURRENT_LOCATION=`pwd`
INSTALL_LOCATION=`pwd`
cd $INSTALL_LOCATION

#Move back to the original location.
cd $CURRENT_LOCATION
COMMAND=$1
SERVICE_NAME=$2
if [ -z "$SERVICE_NAME" ]; then
	SERVICE_NAME=rcladmin
else
	SERVICE_NAME=$2
fi
echo Installing $SERVICE_NAME
	
OS=`uname`

#Linux
if [ $OS = Linux ] ;
then
	SERVICE_LOCATION=/etc/init.d/
elif [ $OS = SunOS ] #Solaris
then
	SERVICE_LOCATION=/etc/init.d/
	#create softlinks in /etc/rc3.d/
	SOFTLINK_LOCATION=/etc/rc3.d/
elif [ $OS = AIX ] #AIX
then
	SERVICE_LOCATION=/etc/
	#create softlinks in /etc/rc.d/rc2.d
	SOFTLINK_LOCATION=/etc/rc.d/rc2.d
elif [ $OS = HP-UX ] #HPUX
then
	SERVICE_LOCATION=/sbin/init.d/
	#create softlinks in /sbin/rc2.d/
	SOFTLINK_LOCATION=/sbin/rc2.d/
fi


if [ $COMMAND = install ] ;
then
	echo "Installing RLKS Admin as a service"
	#copy the rcladmin script to the service location
	echo "#!/bin/sh"> $SERVICE_LOCATION$SERVICE_NAME
	echo "#">> $SERVICE_LOCATION$SERVICE_NAME
	echo "### BEGIN INIT INFO">> $SERVICE_LOCATION$SERVICE_NAME
	echo "# Provides:         $SERVICE_NAME">> $SERVICE_LOCATION$SERVICE_NAME
	echo "# Required-Start:   $local_fs $syslog $network">> $SERVICE_LOCATION$SERVICE_NAME
	echo "# Required-Stop:    $local_fs $syslog $network">> $SERVICE_LOCATION$SERVICE_NAME
	echo "# Default-Start:    2 3 5">> $SERVICE_LOCATION$SERVICE_NAME
	echo "# Default-Stop:     0 1 6">> $SERVICE_LOCATION$SERVICE_NAME
	echo "# Short-Description:Start daemon at boot time">> $SERVICE_LOCATION$SERVICE_NAME
	echo "# Description:      starts the Rational RLKS Reporting Tool Admin">> $SERVICE_LOCATION$SERVICE_NAME
	echo "### END INIT INFO">> $SERVICE_LOCATION$SERVICE_NAME
	echo "SERVICE_NAME=$SERVICE_NAME" >> $SERVICE_LOCATION$SERVICE_NAME	
	echo "ADMIN_INSTALL_LOCATION=\"$INSTALL_LOCATION\"" >>  $SERVICE_LOCATION$SERVICE_NAME 

	cat  $INSTALL_LOCATION/rcladmin >> $SERVICE_LOCATION$SERVICE_NAME
	chmod +x $SERVICE_LOCATION$SERVICE_NAME


	#On LInux, install it as a service
	if [ $OS = Linux ] ;
	then
		chkconfig $SERVICE_NAME on
	else 
	#for all other OS
		cd $SOFTLINK_LOCATION
		ln -s $SERVICE_LOCATION/$SERVICE_NAME S169$SERVICE_NAME
		ln -s $SERVICE_LOCATION/$SERVICE_NAME K169$SERVICE_NAME
	fi
	echo "Installation of $SERVICE_NAME completed"
elif [ $COMMAND = remove ] 
then 
	echo "Removing RLKS Admin service" 
	if [ $OS = Linux ] ;
	then
		chkconfig $SERVICE_NAME off
		chkconfig --del $SERVICE_NAME 
	else 
	#for all other OS
		unlink $SOFTLINK_LOCATION/S169$SERVICE_NAME
		unlink $SOFTLINK_LOCATION/K169$SERVICE_NAME
	fi
	echo removing $SERVICE_LOCATION$SERVICE_NAME
	rm $SERVICE_LOCATION$SERVICE_NAME
	echo "Service $SERVICE_NAME removed"
	
else  
	echo "No option"
fi #install
